/* Generated automatically by the program `genattrtab'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "options.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-attr.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "regs.h"
#include "real.h"
#include "output.h"
#include "toplev.h"
#include "flags.h"
#include "emit-rtl.h"

#define operands recog_data.operand

int
insn_current_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
insn_variable_length_p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
insn_min_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_type cached_type ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 132:  /* bis_SR */
    case 131:  /* bic_SR */
    case 90:  /* call_value_internal */
    case 89:  /* call_internal */
    case 51:  /* extendqipsi2 */
    case 50:  /* extendqihi2 */
    case 5:  /* popa */
    case 4:  /* pop */
    case 2:  /* pusha */
    case 1:  /* push */
      extract_insn_cached (insn);
      return (msp430_cheap_operand (operands[0], VOIDmode) ? 2 : 4) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);

    case 145:  /* *umulsidi3_inline */
    case 144:  /* *mulsidi3_inline */
    case 92:  /* msp430_eh_epilogue */
      return 40 /* 0x28 */;

    case 143:  /* *umulhisi3_inline */
    case 142:  /* *mulhisi3_inline */
      return 24 /* 0x18 */;

    case 69:  /* extend_and_shift2_hipsi2 */
    case 68:  /* extend_and_shift1_hipsi2 */
    case 67:  /* extendhipsi2 */
    case 65:  /* truncpsihi2 */
    case 10:  /* movqipsi */
    case 6:  /* popm */
    case 3:  /* pushm */
    case 141:  /* delay_cycles_1 */
    case 140:  /* delay_cycles_2 */
    case 130:  /* pop_intr_state */
    case 129:  /* push_intr_state */
    case 128:  /* enable_interrupts */
    case 127:  /* disable_interrupts */
    case 126:  /* nop */
    case 95:  /* tablejump */
    case 91:  /* msp430_return */
    case 84:  /* epilogue_helper */
    case 34:  /* *bicpsi_cg */
    case 33:  /* *bichi_cg */
    case 32:  /* *bicqi_cg */
      return 2;

    case 139:  /* delay_cycles_16x */
    case 138:  /* delay_cycles_16 */
      return 14 /* 0xe */;

    case 137:  /* delay_cycles_32x */
      return 28 /* 0x1c */;

    case 136:  /* delay_cycles_32 */
      return 32 /* 0x20 */;

    case 135:  /* delay_cycles_end */
    case 134:  /* delay_cycles_start */
    case 88:  /* msp430_refsym_need_exit */
    case 87:  /* epilogue_start_marker */
    case 86:  /* prologue_end_marker */
    case 85:  /* prologue_start_marker */
      return 0;

    case 133:  /* andneghi3 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 12 /* 0xc */;
        }
      else
        {
	  return 14 /* 0xe */;
        }

    case 94:  /* indirect_jump */
      extract_insn_cached (insn);
      if (register_operand (operands[0], VOIDmode))
        {
	  return 2;
        }
      else
        {
	  return 4;
        }

    case 93:  /* jump */
      return 4;

    case 83:  /* lshrpsi3_430x */
    case 82:  /* lshrhi3_430x */
    case 81:  /* ashrpsi3_430x */
    case 80:  /* ashrhi3_430x */
    case 79:  /* ashlpsi3_430x */
    case 78:  /* ashlhi3_430x */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 2;
        }
      else if (which_alternative == 1)
        {
	  return 4;
        }
      else if (which_alternative == 2)
        {
	  return 8;
        }
      else
        {
	  return 0;
        }

    case 77:  /* lshrsi3_const */
      extract_constrain_insn_cached (insn);
      return 
#line 1178 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430_output_asm_shift_insns (LSHIFTRT, SImode, operands, true));

    case 76:  /* ashrsi3_const */
      extract_constrain_insn_cached (insn);
      return 
#line 1178 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430_output_asm_shift_insns (ASHIFTRT, SImode, operands, true));

    case 75:  /* ashlsi3_const */
      extract_constrain_insn_cached (insn);
      return 
#line 1178 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430_output_asm_shift_insns (ASHIFT, SImode, operands, true));

    case 74:  /* lshrhi3_430 */
      extract_constrain_insn_cached (insn);
      return 
#line 1166 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430_output_asm_shift_insns (LSHIFTRT, HImode, operands, true));

    case 73:  /* ashrhi3_430 */
      extract_constrain_insn_cached (insn);
      return 
#line 1166 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430_output_asm_shift_insns (ASHIFTRT, HImode, operands, true));

    case 72:  /* ashlhi3_430 */
      extract_constrain_insn_cached (insn);
      return 
#line 1166 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430_output_asm_shift_insns (ASHIFT, HImode, operands, true));

    case 71:  /* truncsipsi2 */
    case 18:  /* movsipsi2 */
    case 11:  /* movqi_topbyte */
      return 6;

    case 70:  /* extendpsisi2 */
      return 10 /* 0xa */;

    case 66:  /* extendhisi2 */
      extract_constrain_insn_cached (insn);
      return 
#line 1041 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x_extendhisi (operands, 1));

    case 64:  /* *msp430.md:1000 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 2;
        }
      else if (which_alternative == 1)
        {
	  return (register_operand (operands[0], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[1], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
        }
      else
        {
	  return (register_operand (operands[0], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[1], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
        }

    case 62:  /* *msp430.md:977 */
    case 61:  /* *msp430.md:962 */
    case 60:  /* *msp430.md:948 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 4;
        }
      else if (which_alternative == 1)
        {
	  if (get_attr_extension (insn) == EXTENSION_M)
	    {
	      return 2;
	    }
	  else if ((cached_type = get_attr_type (insn)) == TYPE_SINGLE)
	    {
	      return (msp430_cheap_operand (operands[0], VOIDmode) ? 2 : 4) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
	    }
	  else if (cached_type == TYPE_DOUBLE)
	    {
	      return (register_operand (operands[0], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[1], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
	    }
	  else if (cached_type == TYPE_TRIPLE)
	    {
	      return (register_operand (operands[0], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[2], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
	    }
	  else if (cached_type == TYPE_CMP)
	    {
	      return (register_operand (operands[1], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[2], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
	    }
	  else
	    {
	      return 2;
	    }
        }
      else
        {
	  if (get_attr_extension (insn) == EXTENSION_M)
	    {
	      return 2;
	    }
	  else if ((cached_type = get_attr_type (insn)) == TYPE_SINGLE)
	    {
	      return (msp430_cheap_operand (operands[0], VOIDmode) ? 2 : 4) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
	    }
	  else if (cached_type == TYPE_DOUBLE)
	    {
	      return (register_operand (operands[0], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[1], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
	    }
	  else if (cached_type == TYPE_TRIPLE)
	    {
	      return (register_operand (operands[0], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[2], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
	    }
	  else if (cached_type == TYPE_CMP)
	    {
	      return (register_operand (operands[1], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[2], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
	    }
	  else
	    {
	      return 2;
	    }
        }

    case 58:  /* zero_extendpsisi2 */
      extract_constrain_insn_cached (insn);
      if (
#line 903 "../../../gcc/gcc/config/msp430/msp430.md"
(REGNO (operands[1]) == SP_REGNO))
        {
	  return 18 /* 0x12 */;
        }
      else if (which_alternative == 1)
        {
	  return 6;
        }
      else
        {
	  return 10 /* 0xa */;
        }

    case 57:  /* zero_extendhisipsi2 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 4;
        }
      else
        {
	  return 2;
        }

    case 23:  /* addsipsi3 */
      extract_insn_cached (insn);
      if (register_operand (operands[2], VOIDmode))
        {
	  return 10 /* 0xa */;
        }
      else
        {
	  if (msp430_high_memory_operand (operands[2], VOIDmode))
	    {
	      return 18 /* 0x12 */;
	    }
	  else
	    {
	      return 14 /* 0xe */;
	    }
        }

    case 8:  /* swap_and_shrink */
      extract_constrain_insn_cached (insn);
      if (
#line 295 "../../../gcc/gcc/config/msp430/msp430.md"
(TARGET_LARGE))
        {
	  return 10 /* 0xa */;
        }
      else
        {
	  return 8;
        }

    case 7:  /* grow_and_swap */
      extract_constrain_insn_cached (insn);
      if (
#line 295 "../../../gcc/gcc/config/msp430/msp430.md"
(TARGET_LARGE))
        {
	  return 8;
        }
      else
        {
	  return 6;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      extract_insn_cached (insn);
      if (get_attr_extension (insn) == EXTENSION_M)
        {
	  return 2;
        }
      else if ((cached_type = get_attr_type (insn)) == TYPE_SINGLE)
        {
	  return (msp430_cheap_operand (operands[0], VOIDmode) ? 2 : 4) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
        }
      else if (cached_type == TYPE_DOUBLE)
        {
	  return (register_operand (operands[0], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[1], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
        }
      else if (cached_type == TYPE_TRIPLE)
        {
	  return (register_operand (operands[0], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[2], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
        }
      else if (cached_type == TYPE_CMP)
        {
	  return (register_operand (operands[1], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[2], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
        }
      else
        {
	  return 2;
        }

    }
}

int
insn_default_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_type cached_type ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 132:  /* bis_SR */
    case 131:  /* bic_SR */
    case 90:  /* call_value_internal */
    case 89:  /* call_internal */
    case 51:  /* extendqipsi2 */
    case 50:  /* extendqihi2 */
    case 5:  /* popa */
    case 4:  /* pop */
    case 2:  /* pusha */
    case 1:  /* push */
      extract_insn_cached (insn);
      return (msp430_cheap_operand (operands[0], VOIDmode) ? 2 : 4) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);

    case 145:  /* *umulsidi3_inline */
    case 144:  /* *mulsidi3_inline */
    case 92:  /* msp430_eh_epilogue */
      return 40 /* 0x28 */;

    case 143:  /* *umulhisi3_inline */
    case 142:  /* *mulhisi3_inline */
      return 24 /* 0x18 */;

    case 69:  /* extend_and_shift2_hipsi2 */
    case 68:  /* extend_and_shift1_hipsi2 */
    case 67:  /* extendhipsi2 */
    case 65:  /* truncpsihi2 */
    case 10:  /* movqipsi */
    case 6:  /* popm */
    case 3:  /* pushm */
    case 141:  /* delay_cycles_1 */
    case 140:  /* delay_cycles_2 */
    case 130:  /* pop_intr_state */
    case 129:  /* push_intr_state */
    case 128:  /* enable_interrupts */
    case 127:  /* disable_interrupts */
    case 126:  /* nop */
    case 95:  /* tablejump */
    case 91:  /* msp430_return */
    case 84:  /* epilogue_helper */
    case 34:  /* *bicpsi_cg */
    case 33:  /* *bichi_cg */
    case 32:  /* *bicqi_cg */
      return 2;

    case 139:  /* delay_cycles_16x */
    case 138:  /* delay_cycles_16 */
      return 14 /* 0xe */;

    case 137:  /* delay_cycles_32x */
      return 28 /* 0x1c */;

    case 136:  /* delay_cycles_32 */
      return 32 /* 0x20 */;

    case 135:  /* delay_cycles_end */
    case 134:  /* delay_cycles_start */
    case 88:  /* msp430_refsym_need_exit */
    case 87:  /* epilogue_start_marker */
    case 86:  /* prologue_end_marker */
    case 85:  /* prologue_start_marker */
      return 0;

    case 133:  /* andneghi3 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 12 /* 0xc */;
        }
      else
        {
	  return 14 /* 0xe */;
        }

    case 94:  /* indirect_jump */
      extract_insn_cached (insn);
      if (register_operand (operands[0], VOIDmode))
        {
	  return 2;
        }
      else
        {
	  return 4;
        }

    case 93:  /* jump */
      return 4;

    case 83:  /* lshrpsi3_430x */
    case 82:  /* lshrhi3_430x */
    case 81:  /* ashrpsi3_430x */
    case 80:  /* ashrhi3_430x */
    case 79:  /* ashlpsi3_430x */
    case 78:  /* ashlhi3_430x */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 2;
        }
      else if (which_alternative == 1)
        {
	  return 4;
        }
      else if (which_alternative == 2)
        {
	  return 8;
        }
      else
        {
	  return 0;
        }

    case 77:  /* lshrsi3_const */
      extract_constrain_insn_cached (insn);
      return 
#line 1178 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430_output_asm_shift_insns (LSHIFTRT, SImode, operands, true));

    case 76:  /* ashrsi3_const */
      extract_constrain_insn_cached (insn);
      return 
#line 1178 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430_output_asm_shift_insns (ASHIFTRT, SImode, operands, true));

    case 75:  /* ashlsi3_const */
      extract_constrain_insn_cached (insn);
      return 
#line 1178 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430_output_asm_shift_insns (ASHIFT, SImode, operands, true));

    case 74:  /* lshrhi3_430 */
      extract_constrain_insn_cached (insn);
      return 
#line 1166 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430_output_asm_shift_insns (LSHIFTRT, HImode, operands, true));

    case 73:  /* ashrhi3_430 */
      extract_constrain_insn_cached (insn);
      return 
#line 1166 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430_output_asm_shift_insns (ASHIFTRT, HImode, operands, true));

    case 72:  /* ashlhi3_430 */
      extract_constrain_insn_cached (insn);
      return 
#line 1166 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430_output_asm_shift_insns (ASHIFT, HImode, operands, true));

    case 71:  /* truncsipsi2 */
    case 18:  /* movsipsi2 */
    case 11:  /* movqi_topbyte */
      return 6;

    case 70:  /* extendpsisi2 */
      return 10 /* 0xa */;

    case 66:  /* extendhisi2 */
      extract_constrain_insn_cached (insn);
      return 
#line 1041 "../../../gcc/gcc/config/msp430/msp430.md"
(msp430x_extendhisi (operands, 1));

    case 64:  /* *msp430.md:1000 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 2;
        }
      else if (which_alternative == 1)
        {
	  return (register_operand (operands[0], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[1], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
        }
      else
        {
	  return (register_operand (operands[0], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[1], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
        }

    case 62:  /* *msp430.md:977 */
    case 61:  /* *msp430.md:962 */
    case 60:  /* *msp430.md:948 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 4;
        }
      else if (which_alternative == 1)
        {
	  if (get_attr_extension (insn) == EXTENSION_M)
	    {
	      return 2;
	    }
	  else if ((cached_type = get_attr_type (insn)) == TYPE_SINGLE)
	    {
	      return (msp430_cheap_operand (operands[0], VOIDmode) ? 2 : 4) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
	    }
	  else if (cached_type == TYPE_DOUBLE)
	    {
	      return (register_operand (operands[0], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[1], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
	    }
	  else if (cached_type == TYPE_TRIPLE)
	    {
	      return (register_operand (operands[0], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[2], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
	    }
	  else if (cached_type == TYPE_CMP)
	    {
	      return (register_operand (operands[1], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[2], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
	    }
	  else
	    {
	      return 2;
	    }
        }
      else
        {
	  if (get_attr_extension (insn) == EXTENSION_M)
	    {
	      return 2;
	    }
	  else if ((cached_type = get_attr_type (insn)) == TYPE_SINGLE)
	    {
	      return (msp430_cheap_operand (operands[0], VOIDmode) ? 2 : 4) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
	    }
	  else if (cached_type == TYPE_DOUBLE)
	    {
	      return (register_operand (operands[0], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[1], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
	    }
	  else if (cached_type == TYPE_TRIPLE)
	    {
	      return (register_operand (operands[0], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[2], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
	    }
	  else if (cached_type == TYPE_CMP)
	    {
	      return (register_operand (operands[1], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[2], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
	    }
	  else
	    {
	      return 2;
	    }
        }

    case 58:  /* zero_extendpsisi2 */
      extract_constrain_insn_cached (insn);
      if (
#line 903 "../../../gcc/gcc/config/msp430/msp430.md"
(REGNO (operands[1]) == SP_REGNO))
        {
	  return 18 /* 0x12 */;
        }
      else if (which_alternative == 1)
        {
	  return 6;
        }
      else
        {
	  return 10 /* 0xa */;
        }

    case 57:  /* zero_extendhisipsi2 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 4;
        }
      else
        {
	  return 2;
        }

    case 23:  /* addsipsi3 */
      extract_insn_cached (insn);
      if (register_operand (operands[2], VOIDmode))
        {
	  return 10 /* 0xa */;
        }
      else
        {
	  if (msp430_high_memory_operand (operands[2], VOIDmode))
	    {
	      return 18 /* 0x12 */;
	    }
	  else
	    {
	      return 14 /* 0xe */;
	    }
        }

    case 8:  /* swap_and_shrink */
      extract_constrain_insn_cached (insn);
      if (
#line 295 "../../../gcc/gcc/config/msp430/msp430.md"
(TARGET_LARGE))
        {
	  return 10 /* 0xa */;
        }
      else
        {
	  return 8;
        }

    case 7:  /* grow_and_swap */
      extract_constrain_insn_cached (insn);
      if (
#line 295 "../../../gcc/gcc/config/msp430/msp430.md"
(TARGET_LARGE))
        {
	  return 8;
        }
      else
        {
	  return 6;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      extract_insn_cached (insn);
      if (get_attr_extension (insn) == EXTENSION_M)
        {
	  return 2;
        }
      else if ((cached_type = get_attr_type (insn)) == TYPE_SINGLE)
        {
	  return (msp430_cheap_operand (operands[0], VOIDmode) ? 2 : 4) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
        }
      else if (cached_type == TYPE_DOUBLE)
        {
	  return (register_operand (operands[0], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[1], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
        }
      else if (cached_type == TYPE_TRIPLE)
        {
	  return (register_operand (operands[0], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[2], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
        }
      else if (cached_type == TYPE_CMP)
        {
	  return (register_operand (operands[1], VOIDmode) ? 2 : 4) + (msp430_cheap_operand (operands[2], VOIDmode) ? 0 : 2) + (get_attr_extension (insn) == EXTENSION_X ? 2 : 0);
        }
      else
        {
	  return 2;
        }

    }
}

int
num_delay_slots (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
get_attr_extra_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 60:  /* *msp430.md:948 */
    case 61:  /* *msp430.md:962 */
    case 62:  /* *msp430.md:977 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 0;
        }
      else if (which_alternative == 1)
        {
	  return 4;
        }
      else
        {
	  return 6;
        }

    case 63:  /* *msp430.md:991 */
      return 4;

    case 64:  /* *msp430.md:1000 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 0;
        }
      else if (which_alternative == 1)
        {
	  return 2;
        }
      else
        {
	  return 4;
        }

    case 54:  /* zero_extendqisi2 */
    case 96:  /* cbranchpsi4_real */
    case 97:  /* cbranchqi4_real */
    case 98:  /* cbranchhi4_real */
    case 99:  /* cbranchpsi4_reversed */
    case 100:  /* cbranchqi4_reversed */
    case 101:  /* cbranchhi4_reversed */
    case 102:  /* *bitbranchqi4 */
    case 103:  /* *bitbranchhi4 */
    case 104:  /* *bitbranchpsi4 */
    case 105:  /* *bitbranchqi4 */
    case 106:  /* *bitbranchhi4 */
    case 107:  /* *bitbranchpsi4 */
    case 108:  /* *bitbranchqi4 */
    case 109:  /* *bitbranchhi4 */
    case 110:  /* *bitbranchpsi4 */
    case 111:  /* *bitbranchqi4 */
    case 112:  /* *bitbranchhi4 */
    case 113:  /* *bitbranchpsi4 */
    case 114:  /* *bitbranchqi4_z */
    case 115:  /* *bitbranchhi4_z */
    case 116:  /* *bitbranchpsi4_z */
    case 117:  /* *bitbranchqi4_z */
    case 118:  /* *bitbranchhi4_z */
    case 119:  /* *bitbranchpsi4_z */
    case 120:  /* *bitbranchqi4_z */
    case 121:  /* *bitbranchhi4_z */
    case 122:  /* *bitbranchpsi4_z */
    case 123:  /* *bitbranchqi4_z */
    case 124:  /* *bitbranchhi4_z */
    case 125:  /* *bitbranchpsi4_z */
    case 131:  /* bic_SR */
    case 132:  /* bis_SR */
      return 2;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

enum attr_extension
get_attr_extension (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_type cached_type ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 17:  /* movpsi */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return EXTENSION_NONE;
        }
      else if (((1ULL << which_alternative) & 0xcULL))
        {
	  return EXTENSION_A;
        }
      else
        {
	  return EXTENSION_X;
        }

    case 132:  /* bis_SR */
    case 131:  /* bic_SR */
    case 83:  /* lshrpsi3_430x */
    case 82:  /* lshrhi3_430x */
    case 81:  /* ashrpsi3_430x */
    case 80:  /* ashrhi3_430x */
    case 79:  /* ashlpsi3_430x */
    case 78:  /* ashlhi3_430x */
    case 77:  /* lshrsi3_const */
    case 76:  /* ashrsi3_const */
    case 75:  /* ashlsi3_const */
    case 74:  /* lshrhi3_430 */
    case 73:  /* ashrhi3_430 */
    case 72:  /* ashlhi3_430 */
    case 71:  /* truncsipsi2 */
    case 50:  /* extendqihi2 */
    case 4:  /* pop */
    case 1:  /* push */
      extract_insn_cached (insn);
      if (msp430_high_memory_operand (operands[0], VOIDmode))
        {
	  return EXTENSION_X;
        }
      else
        {
	  return EXTENSION_NONE;
        }

    case 28:  /* subpsi3 */
    case 20:  /* addpsi3 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return EXTENSION_A;
        }
      else
        {
	  return EXTENSION_X;
        }

    case 51:  /* extendqipsi2 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return EXTENSION_NONE;
        }
      else
        {
	  return EXTENSION_X;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    case 21:  /* addqi3 */
    case 22:  /* addhi3 */
    case 23:  /* addsipsi3 */
    case 24:  /* addsi3 */
    case 25:  /* addhi3_cy */
    case 26:  /* addhi3_cy_i */
    case 27:  /* addchi4_cy */
    case 29:  /* subqi3 */
    case 30:  /* subhi3 */
    case 31:  /* subsi3 */
    case 38:  /* andqi3 */
    case 39:  /* andhi3 */
    case 40:  /* andpsi3 */
    case 41:  /* iorqi3 */
    case 42:  /* iorhi3 */
    case 43:  /* iorpsi3 */
    case 44:  /* xorqi3 */
    case 45:  /* xorhi3 */
    case 46:  /* xorpsi3 */
    case 96:  /* cbranchpsi4_real */
    case 97:  /* cbranchqi4_real */
    case 98:  /* cbranchhi4_real */
    case 99:  /* cbranchpsi4_reversed */
    case 100:  /* cbranchqi4_reversed */
    case 101:  /* cbranchhi4_reversed */
      extract_insn_cached (insn);
      if ((cached_type = get_attr_type (insn)) == TYPE_NONE)
        {
	  return EXTENSION_NONE;
        }
      else if (msp430_high_memory_operand (operands[0], VOIDmode))
        {
	  return EXTENSION_X;
        }
      else if ((cached_type == TYPE_DOUBLE) && (msp430_high_memory_operand (operands[1], VOIDmode)))
        {
	  return EXTENSION_X;
        }
      else if (((cached_type == TYPE_TRIPLE) || (cached_type == TYPE_CMP)) && ((msp430_high_memory_operand (operands[1], VOIDmode)) || (msp430_high_memory_operand (operands[2], VOIDmode))))
        {
	  return EXTENSION_X;
        }
      else
        {
	  return EXTENSION_NONE;
        }

    case 3:  /* pushm */
    case 6:  /* popm */
    case 65:  /* truncpsihi2 */
    case 67:  /* extendhipsi2 */
    case 68:  /* extend_and_shift1_hipsi2 */
    case 69:  /* extend_and_shift2_hipsi2 */
      return EXTENSION_M;

    case 19:  /* *movpsihi2_lo */
      return EXTENSION_A;

    case 2:  /* pusha */
    case 5:  /* popa */
      return EXTENSION_X;

    case 145:  /* *umulsidi3_inline */
    case 144:  /* *mulsidi3_inline */
    case 143:  /* *umulhisi3_inline */
    case 142:  /* *mulhisi3_inline */
    case 141:  /* delay_cycles_1 */
    case 140:  /* delay_cycles_2 */
    case 139:  /* delay_cycles_16x */
    case 138:  /* delay_cycles_16 */
    case 137:  /* delay_cycles_32x */
    case 136:  /* delay_cycles_32 */
    case 135:  /* delay_cycles_end */
    case 134:  /* delay_cycles_start */
    case 130:  /* pop_intr_state */
    case 129:  /* push_intr_state */
    case 128:  /* enable_interrupts */
    case 127:  /* disable_interrupts */
    case 126:  /* nop */
    case 95:  /* tablejump */
    case 94:  /* indirect_jump */
    case 93:  /* jump */
    case 92:  /* msp430_eh_epilogue */
    case 91:  /* msp430_return */
    case 88:  /* msp430_refsym_need_exit */
    case 87:  /* epilogue_start_marker */
    case 86:  /* prologue_end_marker */
    case 85:  /* prologue_start_marker */
    case 84:  /* epilogue_helper */
    case 10:  /* movqipsi */
    case 8:  /* swap_and_shrink */
    case 7:  /* grow_and_swap */
    case 89:  /* call_internal */
    case 90:  /* call_value_internal */
      return EXTENSION_NONE;

    default:
      extract_insn_cached (insn);
      if ((msp430_high_memory_operand (operands[0], VOIDmode)) || (msp430_high_memory_operand (operands[1], VOIDmode)))
        {
	  return EXTENSION_X;
        }
      else
        {
	  return EXTENSION_NONE;
        }

    }
}

int
get_attr_length_multiplier (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 30:  /* subhi3 */
    case 29:  /* subqi3 */
    case 28:  /* subpsi3 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return 1;
        }
      else
        {
	  return 2;
        }

    case 54:  /* zero_extendqisi2 */
    case 56:  /* zero_extendhisi2 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 1;
        }
      else
        {
	  return 2;
        }

    case 24:  /* addsi3 */
    case 31:  /* subsi3 */
    case 67:  /* extendhipsi2 */
    case 68:  /* extend_and_shift1_hipsi2 */
    case 69:  /* extend_and_shift2_hipsi2 */
      return 2;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 1;

    }
}

enum attr_type
get_attr_type (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 96:  /* cbranchpsi4_real */
    case 97:  /* cbranchqi4_real */
    case 98:  /* cbranchhi4_real */
    case 99:  /* cbranchpsi4_reversed */
    case 100:  /* cbranchqi4_reversed */
    case 101:  /* cbranchhi4_reversed */
      return TYPE_CMP;

    case 20:  /* addpsi3 */
    case 21:  /* addqi3 */
    case 22:  /* addhi3 */
    case 23:  /* addsipsi3 */
    case 24:  /* addsi3 */
    case 25:  /* addhi3_cy */
    case 26:  /* addhi3_cy_i */
    case 27:  /* addchi4_cy */
    case 28:  /* subpsi3 */
    case 29:  /* subqi3 */
    case 30:  /* subhi3 */
    case 31:  /* subsi3 */
    case 38:  /* andqi3 */
    case 39:  /* andhi3 */
    case 40:  /* andpsi3 */
    case 41:  /* iorqi3 */
    case 42:  /* iorhi3 */
    case 43:  /* iorpsi3 */
    case 44:  /* xorqi3 */
    case 45:  /* xorhi3 */
    case 46:  /* xorpsi3 */
      return TYPE_TRIPLE;

    case 1:  /* push */
    case 2:  /* pusha */
    case 3:  /* pushm */
    case 4:  /* pop */
    case 5:  /* popa */
    case 6:  /* popm */
    case 50:  /* extendqihi2 */
    case 51:  /* extendqipsi2 */
    case 71:  /* truncsipsi2 */
    case 72:  /* ashlhi3_430 */
    case 73:  /* ashrhi3_430 */
    case 74:  /* lshrhi3_430 */
    case 75:  /* ashlsi3_const */
    case 76:  /* ashrsi3_const */
    case 77:  /* lshrsi3_const */
    case 78:  /* ashlhi3_430x */
    case 79:  /* ashlpsi3_430x */
    case 80:  /* ashrhi3_430x */
    case 81:  /* ashrpsi3_430x */
    case 82:  /* lshrhi3_430x */
    case 83:  /* lshrpsi3_430x */
    case 89:  /* call_internal */
    case 90:  /* call_value_internal */
    case 131:  /* bic_SR */
    case 132:  /* bis_SR */
      return TYPE_SINGLE;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    case 7:  /* grow_and_swap */
    case 8:  /* swap_and_shrink */
    case 10:  /* movqipsi */
    case 84:  /* epilogue_helper */
    case 85:  /* prologue_start_marker */
    case 86:  /* prologue_end_marker */
    case 87:  /* epilogue_start_marker */
    case 88:  /* msp430_refsym_need_exit */
    case 91:  /* msp430_return */
    case 92:  /* msp430_eh_epilogue */
    case 93:  /* jump */
    case 94:  /* indirect_jump */
    case 95:  /* tablejump */
    case 126:  /* nop */
    case 127:  /* disable_interrupts */
    case 128:  /* enable_interrupts */
    case 129:  /* push_intr_state */
    case 130:  /* pop_intr_state */
    case 134:  /* delay_cycles_start */
    case 135:  /* delay_cycles_end */
    case 136:  /* delay_cycles_32 */
    case 137:  /* delay_cycles_32x */
    case 138:  /* delay_cycles_16 */
    case 139:  /* delay_cycles_16x */
    case 140:  /* delay_cycles_2 */
    case 141:  /* delay_cycles_1 */
    case 142:  /* *mulhisi3_inline */
    case 143:  /* *umulhisi3_inline */
    case 144:  /* *mulsidi3_inline */
    case 145:  /* *umulsidi3_inline */
      return TYPE_NONE;

    default:
      return TYPE_DOUBLE;

    }
}

int
eligible_for_delay (rtx_insn *delay_insn ATTRIBUTE_UNUSED, int slot, 
		   rtx_insn *candidate_insn, int flags ATTRIBUTE_UNUSED)
{
  rtx_insn *insn ATTRIBUTE_UNUSED;

  if (num_delay_slots (delay_insn) == 0)
    return 0;
  gcc_assert (slot < 0);

  if (!INSN_P (candidate_insn))
    return 0;

  insn = candidate_insn;
  switch (slot)
    {
    default:
      gcc_unreachable ();
    }
}

int
eligible_for_annul_true (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
eligible_for_annul_false (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
const_num_delay_slots (rtx_insn *insn)
{
  switch (recog_memoized (insn))
    {
    default:
      return 1;
    }
}

EXPORTED_CONST int length_unit_log = 0;
